function get_element_position(element)
  {
  var xPosition = 0;
  var yPosition = 0;

  while(element &&
	!isNaN( element.offsetLeft ) &&
	!isNaN( element.offsetTop ))
    {
    xPosition += (element.offsetLeft - element.scrollLeft + element.clientLeft);
    yPosition += (element.offsetTop - element.scrollTop + element.clientTop);
    element = element.offsetParent;
    }
  return { x: xPosition, y: yPosition };
  }

function resize_window(w, h)
  {
  window.resizeTo(
            w + (window.outerWidth - window.innerWidth),
            h + (window.outerHeight - window.innerHeight));
  }

function stop_propagate(e)
  {
  var evt = e ? e:window.event;
  if (evt.stopPropagation)
    evt.stopPropagation();
  if(evt.cancelBubble!=null)
    evt.cancelBubble = true;
  }

/**
 * John Resig, erklaert auf Flexible Javascript Events
 */

function add_event_handler( obj, type, fn )
  {
  if(obj.addEventListener)
    {
    obj.addEventListener( type, fn, false );
    }
  else if (obj.attachEvent)
    {
    obj["e"+type+fn] = fn;
    obj[type+fn] = function() { obj["e"+type+fn]( window.event ); };
    obj.attachEvent( "on"+type, obj[type+fn] );
    }
  }

function get_didl_elements(el, name)
  {
  if(el.getElementsByTagNameNS)
    return el.getElementsByTagNameNS("*", name);
  else
    return null;
  }

function get_didl_element(el, name)
  {
  if(el.getElementsByTagNameNS)
    {
    if(el.getElementsByTagNameNS("*", name)[0] != null)
      return el.getElementsByTagNameNS("*", name)[0].textContent;
    else
      return null;
    }
  else
    return null;
  }


/* Ge the upnp duration */
function get_duration(el)
  {
  var res, ret, i;
  res = el.getElementsByTagName("res");

  for(i = 0; i  < res.length; i++)
    {
    ret = res[i].getAttribute("duration");
    if(ret != null)
      return ret;
    }
  return null;
  }

/* Ge the upnp duration */
function didl_get_filename(el)
  {
  var res, i;
  res = el.getElementsByTagName("res");
  for(i = 0; i < res.length; i++)
    {
    if(res[i].textContent.indexOf("file://") == 0)
      return res[i].textContent.substring(7);
    }
  return null;
  }

function format_duration_str(dur)
  {
  var idx;
  if(dur == null)
    return "-:--";
  idx = dur.lastIndexOf(".");
  if(idx >= 0)
    dur = dur.substr(0, idx);
  if(dur.charAt(0) == "0")
    dur = dur.substr(1);
  return dur;
  }

function get_duration_num(dur)
  {
  var i;
  var ret = 0;
  var split;

  if(dur == null)
    return 0.0;
  split = dur.split(":");

  for(i = 0; i < split.length; i++)
    {
    ret *= 60;
    ret += parseFloat(split[i]);
    }
  return ret;
  }

function get_duration_str(dur)
  {
  var ret;
  var hours;
  var minutes;
  var seconds;

  hours = Math.floor(dur / 3600);
  dur -= hours * 3600;

  minutes = Math.floor(dur / 60);
  dur -= minutes * 60;

  seconds = Math.floor(dur);

  if(hours > 0)
    {
    ret = hours.toString() + ':';

    if(minutes < 10)
      ret += "0";
    ret += minutes.toString() + ':';

    if(seconds < 10)
      ret += "0";
    ret += seconds.toString();
    }
  else
    {
    ret = minutes.toString() + ':';
    if(seconds < 10)
      ret += "0";
    ret += seconds.toString();
    }
  return ret;
  }

function get_extension(str)
  {
  var ret = null;
  var idx;
  var idx2;
  var rx;

  idx = str.lastIndexOf(".");
  if(idx < 0)
    return null;

  idx2 = str.lastIndexOf("/");
  if((idx2 < 0) || (idx2 > idx))
    return null;

  ret = str.substr(idx+1);
  if((ret.length < 1) || (ret.length > 4))
    return null;

  rx = new RegExp("^[a-z0-9]+$", "i");
  if(rx.test(ret) != true)
    return null;

  return ret;
  }

